// TODO Insert the appropriate synchronization to ensure that the public API of this class can be
// used safely by multiple threads. 
// In particular (but not exclusively), ensure that there are no data races and that no money is 
// accidentially "lost" or "created".
// Do not insert sleep statements or otherwise change the semantics of the program,
// besides making it concurrency-correct.
public class BankAccount {
    final public int id;
    private int balance;

    public BankAccount(int id, int balance) {
        this.id = id;
        this.balance = balance;
    }

    public int getBalance() {
        return balance;
    }

    // Returns false if the account does not have enough money to transfer the given
    // amount to the other account. Returns true if the transfer was successful.
    public boolean transferToOther(int amount, BankAccount other) {
        if (amount < 0) {
            // Since this is a programming error throw an exception.
            throw new IllegalArgumentException("Cannot transfer negative amount.");
        }

        if (amount > this.balance) {
            return false;
        } else {
            this.balance -= amount;
            other.balance += amount;
            return true;
        }
    }
}
