// Do not modify this source file!
// However, you can run the main method to see the effect of incorrect synchronization (sometimes).
public class Main {
    // Perform many transfers between accounts to increase the likelihood that concurrency problems
    // manifest themselves.
    private static final int ITERATIONS = 100000;

    public static void main(String[] args) throws InterruptedException {
        BankAccount a = new BankAccount(1337, 1000*ITERATIONS);
        BankAccount b = new BankAccount(42, 1000*ITERATIONS);

        printStatus(a, b);

        Thread t1 = new Thread(() -> {
                for (int i = 0; i < ITERATIONS; i++) {
                    a.transferToOther(20, b);
                    b.transferToOther(5, a);
                    a.transferToOther(15, b);
                    b.transferToOther(50, a);
                    a.transferToOther(10, b);
                }
            }
        );
        Thread t2 = new Thread(() -> {
                for (int i = 0; i < ITERATIONS; i++) {
                    b.transferToOther(10, a);
                    a.transferToOther(20, b);
                    b.transferToOther(30, a);
                    a.transferToOther(100, b);
                    b.transferToOther(3, a);
                }
            }
        );

        t1.start();
        t2.start();
        // Wait for all threads to finish.
        t1.join();
        t2.join();

        printStatus(a, b);
    }

    private static void printStatus(BankAccount a, BankAccount b) {
        System.out.println("A's balance: " + a.getBalance());
        System.out.println("B's balance: " + b.getBalance());
        System.out.println("Total money in the system: " + (a.getBalance() + b.getBalance()));
    }
}